*  FILE NAME: BROW.PRG
*  BY: Donald Reese
*  GEmail   DBMS
*  DATE: March 8, 1991
*  DESC: Doesn't require any arrays to be called for incremental indexes
*  DESC: Written to allow generic lookup for validation purposes
*  DESC: Uses functions in personal library that will not compile here
*  DESC: functions are 'msg/ntxmeter/boxline'
*  DESC: Based on code found in GENFUNC - substitute dbfname and dbfindex
*  DESC: Add any code for editing desired
clear screen
help_clr = 'w/b,b/w'
stand_clr = 'b/w,w/b'
set color to w/b,b/w
if !file('test.ntx')
use test
meterbox(20)
INDEX ON ntxmeter(name,20) TO test
close databases
endif
set color to w/b,b/w
USE test index test
CLEAR SCREEN
_brow()
return
*----------------------------------------------------------
FUNCTION _BROW
GO TOP
seekvar = ''
blankspc = SPACE(77)
oldrec = 0
newrec = 0
SAVE SCREEN
DECLARE field_list[FCOUNT()]
FOR n = 1 TO FCOUNT()
   * each element contains one field name
   field_list[M->n] = FIELDNAME(M->n)
NEXT
* window specified
@ 2,2,21,78 BOX "͸Գ"
DBEDIT(3,3,20,77, M->field_list, "indbrow", 0, 0, " ", "")
RESTORE SCREEN
RETURN ' '
*------------------------------------------------------------
FUNCTION indbrow
PARAMETERS mode , f_script
PRIVATE ret_val
* assume normal return
ret_val = 1
* save last keystroke
keystroke = LASTKEY()
DO CASE
CASE M->mode = 0
   * idle
   DO CASE
   CASE M->keystroke = 5
      seekvar = ''
      ret_val = 1
   CASE M->keystroke = 24
      seekvar = ''
      ret_val = 1
   CASE M->keystroke = 18
      seekvar = ''
      ret_val = 1
   CASE M->keystroke = 3
      seekvar = ''
      ret_val = 1
   CASE M->keystroke = 30
      seekvar = ''
      ret_val = 1
   CASE M->keystroke = 31
      seekvar = ''
      ret_val = 1
   ENDCASE
   @ 22,01 TO 24,79 double
   @ 23,02 SAY blankspc
   @ 23,03 SAY 'Locate (by Index) First --> '+seekvar
CASE M->mode = 1
   * bof bang
   msg('Beginning of FILE!!!')
CASE M->mode = 2
   * eof bang
   msg('END of FILE!!!')
CASE M->mode = 3
   * file is empty
   msg('File is EMpty!')
CASE M->mode = 4
   * keystroke exception
   DO CASE
   CASE M->keystroke = 8
      seekvar = LEFT(seekvar,LEN(seekvar)-1)
      ret_val = 1
   CASE M->keystroke >32 .and. m->keystroke < 127
      oldrec = RECNO()
      seekvar = seekvar+UPPER(CHR(m->keystroke))
      SEEK seekvar
      IF FOUND()
         ret_val = 2
      ELSE
         tone(100,2)
         tone(300,1)
         tone(200,2)
         seekvar = LEFT(seekvar,LEN(seekvar)-1)
         GOTO oldrec
         ret_val = 1
      ENDIF
   CASE M->keystroke = 27
      * exit requested..quit dbedit
      ret_val = 0
   CASE M->keystroke = 7 .AND. .NOT. EOF() .AND. LASTREC() <> 0
      * delete key..toggle deleted() flag
      IF DELETED()
         RECALL
         @ 0,60 say '              '
      ELSE
         DELETE
         @ 0,60 say 'Record Deleted'
      ENDIF
   CASE M->keystroke = 13 .AND. .NOT. EOF() .AND. LASTREC() <> 0
      *  place any keyboard values here
      *  or edit routines
      *  or whatever
      ret_val = 0
   ENDCASE
   @ 22,01 TO 24,79 double
   @ 23,02 SAY blankspc
   @ 23,03 SAY 'Locate (by Index) First --> '+seekvar
ENDCASE
RETURN M->ret_val
*Formatted by: dANALYST Ver. 7.3y on March 8, 1991 at 1:06 AM.
